from enum import Enum, auto
import skimage.restoration

class Color(Enum):
    RED = auto()
    GREEN_RIGHT = auto()
    GREEN_BOTTOM = auto()
    BLUE = auto()

    def __str__(self):
        return self.name.lower()

# Among:
# - `wavelet`
# - `bilateral`
# - `tv_chambolle`
def denoise(imageNpArray, denoiserName):
    skImageRestorationDenoise = getattr(skimage.restoration, f'denoise_{denoiserName}')

    match denoiserName:
        case 'wavelet':
            imageDenoisedNpArray = skImageRestorationDenoise(imageNpArray, rescale_sigma=True)
        case 'bilateral':
            imageDenoisedNpArray = skImageRestorationDenoise(imageNpArray, sigma_color=0.05, sigma_spatial=15)
        case 'tv_chambolle':
            imageDenoisedNpArray = skImageRestorationDenoise(imageNpArray, weight=0.2)
    return imageDenoisedNpArray

class iterativeMean:
    mean = 0
    numberOfElementsInMean = 0

    def add(self, element):
        self.mean = ((self.mean * self.numberOfElementsInMean) + element) / (self.numberOfElementsInMean + 1)
        self.numberOfElementsInMean += 1